// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'KeyboardLayoutEditor.pas' rev: 6.00

#ifndef KeyboardLayoutEditorHPP
#define KeyboardLayoutEditorHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Forms.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Keyboard.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Keyboardlayouteditor
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TKeyClickedEvent)(Keyboard::TKey* Key);

class DELPHICLASS TKeyboardLayoutEditor;
class PASCALIMPLEMENTATION TKeyboardLayoutEditor : public Extctrls::TCustomPanel 
{
	typedef Extctrls::TCustomPanel inherited;
	
private:
	Keyboard::TKeyCollection* FKeys;
	bool FDrag;
	bool FMouseDown;
	int FX0;
	int FY0;
	int FHGrid;
	int FVGrid;
	Graphics::TFont* FDefaultFont;
	Graphics::TColor FGridColor;
	TKeyClickedEvent FOnKeyClicked;
	TKeyClickedEvent FOnKeyRightClicked;
	bool FLimitDesignArea;
	Keyboard::TKeyControl* __fastcall CreateKeyControl(void);
	void __fastcall CreateControls(void);
	void __fastcall DestroyControls(void);
	void __fastcall ShowPropertiesForm(Keyboard::TKey* Key);
	void __fastcall CreateGrid(void);
	void __fastcall BtnMouseMove(System::TObject* Sender, Classes::TShiftState Shift, int X, int Y);
	void __fastcall BtnMouseDown(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	void __fastcall BtnMouseUp(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	void __fastcall BtnClick(System::TObject* Sender);
	Keyboard::TKey* __fastcall GetKey(int i);
	void __fastcall SetGridColor(const Graphics::TColor Value);
	void __fastcall SetDefaultFont(const Graphics::TFont* Value);
	
protected:
	virtual void __fastcall Loaded(void);
	
public:
	__property Keyboard::TKey* Keys[int i] = {read=GetKey};
	__fastcall virtual TKeyboardLayoutEditor(Classes::TComponent* AOwner);
	__fastcall virtual ~TKeyboardLayoutEditor(void);
	void __fastcall LoadLayout(AnsiString LayoutFileName);
	void __fastcall SaveLayout(AnsiString LayoutFileName);
	void __fastcall ClearAll(void);
	void __fastcall NewKey(void);
	void __fastcall DeleteKey(Keyboard::TKey* Key);
	void __fastcall SetKeyFont(Graphics::TFont* Font);
	void __fastcall ShowKeyPropertiesDialog(Keyboard::TKey* Key);
	void __fastcall MoveKeysLeft(int Delta = 0x4);
	void __fastcall MoveKeysRight(int Delta = 0x4);
	void __fastcall MoveKeysUp(int Delta = 0x4);
	void __fastcall MoveKeysDown(int Delta = 0x4);
	
__published:
	__property Align  = {default=0};
	__property BevelOuter  = {default=2};
	__property BevelInner  = {default=0};
	__property BevelWidth  = {default=1};
	__property BorderStyle  = {default=0};
	__property BorderWidth  = {default=0};
	__property Color  = {default=-2147483633};
	__property Constraints ;
	__property Enabled  = {default=1};
	__property OnEnter ;
	__property OnExit ;
	__property Graphics::TFont* DefaultKeyFont = {read=FDefaultFont, write=SetDefaultFont};
	__property Graphics::TColor GridColor = {read=FGridColor, write=SetGridColor, nodefault};
	__property bool LimitDesignArea = {read=FLimitDesignArea, write=FLimitDesignArea, nodefault};
	__property TKeyClickedEvent OnKeyClicked = {read=FOnKeyClicked, write=FOnKeyClicked};
	__property TKeyClickedEvent OnKeyRightClicked = {read=FOnKeyRightClicked, write=FOnKeyRightClicked};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TKeyboardLayoutEditor(HWND ParentWindow) : Extctrls::TCustomPanel(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Keyboardlayouteditor */
using namespace Keyboardlayouteditor;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// KeyboardLayoutEditor
